/**
  * @author Oscar Sanchez Caadas. 14 Nov 2011
 * 
 */

import java.io.FileNotFoundException;
import java.io.ObjectInputStream;
import java.io.ObjectOutputStream;
import java.io.Serializable;
import java.net.ServerSocket;
import java.net.Socket;
import java.security.KeyPair;
import java.security.KeyPairGenerator;
import java.security.KeyStore;
import java.security.NoSuchAlgorithmException;
import java.security.NoSuchProviderException;
import java.util.ArrayList;
import java.util.Date;
import java.util.List;
import javax.net.ServerSocketFactory;
import javax.net.ssl.KeyManagerFactory;
import javax.net.ssl.SSLContext;
import javax.net.ssl.SSLServerSocket;

public class Directory implements Serializable {

	/**
	 *  Directory server is responsible for launching the Entities i assign these to the users
	 */
	private static final long serialVersionUID = -3602431190906632140L;
	public List<Entity> listaEntities = new ArrayList<Entity>();

	public static void main(String[] args) {

		Directory directory = new Directory();
		directory.WaitClient();

	}

	public SSLServerSocket getServer(int port) throws Exception {

		KeyStore kstore = JKS.JKSstart("Directory");
		KeyManagerFactory kmf = KeyManagerFactory.getInstance("SunX509");
		kmf.init(kstore, "Directory_pw".toCharArray());
		SSLContext sslcontext = SSLContext.getInstance("SSLv3");
		sslcontext.init(kmf.getKeyManagers(), null, null);
		ServerSocketFactory ssf = sslcontext.getServerSocketFactory();
		SSLServerSocket serversocket = (SSLServerSocket) ssf
				.createServerSocket(port);
		return serversocket;

	}

	public void WaitClient() {

		try {
			int port = 25000;
			int A = 5; //**Must be modified to number of Users
			int N = (A * 2) + 10;
			boolean encontrado = false;

			listaEntities = lanzaEntity(port, N + 1); // Fill the list of Entities
			System.out.println("Lanzamos socket");
			ServerSocket socketDirectory = new ServerSocket(33330); 

			while (true) {
				port++;
				// Client is expected
				Socket sslDirectory = socketDirectory.accept();//**Must be modified to SSLsocket

				// Arrives Client
				System.out.println("Aceptado cliente");

				// User received
				ObjectInputStream ois = new ObjectInputStream(
						sslDirectory.getInputStream());
				User usuario = new User();
				usuario = (User) ois.readObject();
				String nameUser = usuario.getName();
				

				encontrado = false;

				// See if the user has assigned an Entity
				for (Entity ent : listaEntities) {
					if (nameUser.equalsIgnoreCase(ent.nameUser)) { 
						encontrado = true;
						port = ent.getPort();
						ent.setLibre(false);
						usuario.setPort(port);
						usuario.setIdEntity(ent.getIdEntity());
						usuario.setListaEntities(listaEntities);
						break;
					}
				}
				
				// Look for free Entity 
				if (encontrado == false) {
					for (Entity ent : listaEntities) {
						if (ent.isLibre()) {
							encontrado = true;
							ent.setNameUsuario(nameUser);
							port = ent.getPort();
							ent.setLibre(false);
							usuario.setPort(port);
							usuario.setIdEntity(ent.getIdEntity());
							usuario.setListaEntities(listaEntities);
							break;
						}
					}
				}
				if (encontrado) {
					// We send the new user with the port
					ObjectOutputStream oos = new ObjectOutputStream(
							sslDirectory.getOutputStream());
					usuario.setPort(port);
					oos.writeObject(usuario);
				} else {
					System.out.println("There are no free Entities.");
				}

			}

		} catch (Exception e) {
			e.printStackTrace();
		}

	}

	public KeyPair GenkeyPair() throws NoSuchAlgorithmException,
			NoSuchProviderException {
		KeyPairGenerator generadorRSA = KeyPairGenerator.getInstance("RSA",
				"BC"); // Uses the Provider BC
		generadorRSA.initialize(512);
		KeyPair keyPair = generadorRSA.generateKeyPair();
		return keyPair;
	}

	public List<Entity> lanzaEntity(int port, int N)
			throws NoSuchAlgorithmException, NoSuchProviderException {
		List<Entity> listaEntities = new ArrayList<Entity>();
		SaveFile log = new SaveFile();

		for (int i = 1; i < N; i++) {
			Entity entity = new Entity();
			entity.setPort(port + i);
			entity.setIdEntity(i);
			entity.setNameEntity("Entity" + String.valueOf(i));
			entity.setLibre(true);
			KeyPairGenerator RSAkeyPairGen = KeyPairGenerator
					.getInstance("RSA");
			RSAkeyPairGen.initialize(2048);
			KeyPair keyRSA = RSAkeyPairGen.generateKeyPair();
			entity.setPrivateKey(keyRSA.getPrivate());
			entity.setPublicKey(keyRSA.getPublic());
			listaEntities.add(entity);
			// Create a log for each Entity created
			try {
				log.saveLogListaEntity(new Date() + " \t "
						+ listaEntities.get(i - 1).getNameEntity() + " \t "
						+ listaEntities.get(i - 1).getPort() + " \t \n");
			} catch (FileNotFoundException e) {
				e.printStackTrace();
			}
			entity.start();
		}
		for (int i = 0; i < N - 1; i++) {
			listaEntities.get(i).setListaEntities(listaEntities);
		}

		return listaEntities;

	}

}
