/**
  * @author Oscar Sanche Caadas. 14 Nov 2011
 * 
 */
import java.io.IOException;
import java.io.Serializable;
import java.security.InvalidKeyException;
import java.security.NoSuchAlgorithmException;
import java.security.NoSuchProviderException;
import java.security.PrivateKey;
import java.security.PublicKey;
import java.security.Security;

import javax.crypto.BadPaddingException;
import javax.crypto.Cipher;
import javax.crypto.IllegalBlockSizeException;
import javax.crypto.NoSuchPaddingException;
import javax.crypto.SealedObject;

import org.bouncycastle.jce.provider.BouncyCastleProvider;

public class Epbk_x {
	/**
	 * Packet encrypted by public key
	 * 
	 */
	// Method to encrypt of Entities
	public SealedObject ciphEpbk_x(String keySym, int len, PublicKey rsaPubKey) {
		try {
			Security.addProvider(new BouncyCastleProvider());
			Cipher cipherRSA;
			cipherRSA = Cipher.getInstance(
					"RSA/None/OAEPWithSHA1AndMGF1Padding", "BC");
			cipherRSA.init(Cipher.ENCRYPT_MODE, rsaPubKey);
			epbk_xPack epbkp = new epbk_xPack();
			epbkp.setKeySym(keySym);
			epbkp.setLen(len);
			SealedObject epbk_ciph = new SealedObject((Serializable) epbkp,
					cipherRSA);
			return epbk_ciph;

		} catch (NoSuchAlgorithmException e) {
			e.printStackTrace();
		} catch (NoSuchProviderException e) {
			e.printStackTrace();
		} catch (NoSuchPaddingException e) {
			e.printStackTrace();
		} catch (InvalidKeyException e) {
			e.printStackTrace();
		} catch (IllegalBlockSizeException e) {
			e.printStackTrace();
		} catch (IOException e) {
			e.printStackTrace();
		}
		return null;
	}

	// Method to decrypt of Entities
	public Object descyphEpbk_x(SealedObject ePbk_dciph, PrivateKey rsaPrvKey) {
		try {
			Security.addProvider(new BouncyCastleProvider());
			Cipher dcipherRSA;
			dcipherRSA = Cipher.getInstance(
					"RSA/None/OAEPWithSHA1AndMGF1Padding", "BC");
			dcipherRSA.init(Cipher.DECRYPT_MODE, rsaPrvKey);

			return ePbk_dciph.getObject(dcipherRSA);
		} catch (InvalidKeyException e) {
			e.printStackTrace();
		} catch (IllegalBlockSizeException e) {
			e.printStackTrace();
		} catch (BadPaddingException e) {
			e.printStackTrace();
		} catch (NoSuchAlgorithmException e) {
			e.printStackTrace();
		} catch (NoSuchProviderException e) {
			e.printStackTrace();
		} catch (NoSuchPaddingException e) {
			e.printStackTrace();
		} catch (IOException e) {
			e.printStackTrace();
		} catch (ClassNotFoundException e) {
			e.printStackTrace();
		}
		return null;
	}

}
