/**
  * @author Oscar Sanchez Caadas. 14 Nov 2011
 * 
 */

import java.io.IOException;
import java.io.Serializable;
import java.security.InvalidKeyException;
import java.security.NoSuchAlgorithmException;
import java.security.NoSuchProviderException;
import java.security.Security;

import javax.crypto.BadPaddingException;
import javax.crypto.Cipher;
import javax.crypto.IllegalBlockSizeException;
import javax.crypto.NoSuchPaddingException;
import javax.crypto.SealedObject;
import javax.crypto.SecretKey;
import org.bouncycastle.jce.provider.BouncyCastleProvider;

public class Ex {
	/**
	 * Packet encrypted by symmetric key 
	 * 
	 */
	// Method to encrypt of relay Entity
	public SealedObject cyphE_x(String role, int idNextEntity,
			Packet nextPacket, SecretKey keySym) {
		try {
			Security.addProvider(new BouncyCastleProvider());
			Cipher cifrador;
			cifrador = Cipher.getInstance("DES/ECB/PKCS7Padding", "BC");
			cifrador.init(Cipher.ENCRYPT_MODE, keySym);
			exPack exp = new exPack();
			exp.setRole(role);
			exp.setIdNextEntity(idNextEntity);
			exp.setNextPacket(nextPacket);
			SealedObject ep_ciph = new SealedObject((Serializable) exp,
					cifrador);
			return ep_ciph;

		} catch (NoSuchAlgorithmException e) {
			e.printStackTrace();
		} catch (NoSuchProviderException e) {
			e.printStackTrace();
		} catch (NoSuchPaddingException e) {
			e.printStackTrace();
		} catch (InvalidKeyException e) {
			e.printStackTrace();
		} catch (IllegalBlockSizeException e) {
			e.printStackTrace();
		} catch (IOException e) {
			e.printStackTrace();
		}
		return null;

	}

	// Method to encrypt of origin Entity
	public SealedObject cyphE_x(String role, String messageId,
			int idNextEntity, Packet nextPacket, SecretKey keySym) {
		try {
			Security.addProvider(new BouncyCastleProvider());
			Cipher cifrador;
			cifrador = Cipher.getInstance("DES/ECB/PKCS7Padding", "BC");
			cifrador.init(Cipher.ENCRYPT_MODE, keySym);
			exPack exp = new exPack();
			exp.setRole(role);
			exp.setMessageId(messageId);
			exp.setIdNextEntity(idNextEntity);
			exp.setNextPacket(nextPacket);
			SealedObject ep_ciph = new SealedObject((Serializable) exp,
					cifrador);
			return ep_ciph;

		} catch (NoSuchAlgorithmException e) {
			e.printStackTrace();
		} catch (NoSuchProviderException e) {
			e.printStackTrace();
		} catch (NoSuchPaddingException e) {
			e.printStackTrace();
		} catch (InvalidKeyException e) {
			e.printStackTrace();
		} catch (IllegalBlockSizeException e) {
			e.printStackTrace();
		} catch (IOException e) {
			e.printStackTrace();
		}
		return null;

	}

	// Method to encrypt of destiny Entity
	public SealedObject cyphE_x(String role, int authz, int op, int len2,
			String data, int idNextEntity, Packet nextPacket, SecretKey keySym) {
		try {
			Security.addProvider(new BouncyCastleProvider());
			Cipher cifrador;
			cifrador = Cipher.getInstance("DES/ECB/PKCS7Padding", "BC");
			cifrador.init(Cipher.ENCRYPT_MODE, keySym);
			exPack exp = new exPack();
			exp.setRole(role);
			exp.setAuthz(authz);
			exp.setOp(op);
			exp.setLen2(len2);
			exp.setData(data);
			exp.setIdNextEntity(idNextEntity);
			exp.setNextPacket(nextPacket);
			SealedObject ep_ciph = new SealedObject((Serializable) exp,
					cifrador);
			return ep_ciph;

		} catch (NoSuchAlgorithmException e) {
			e.printStackTrace();
		} catch (NoSuchProviderException e) {
			e.printStackTrace();
		} catch (NoSuchPaddingException e) {
			e.printStackTrace();
		} catch (InvalidKeyException e) {
			e.printStackTrace();
		} catch (IllegalBlockSizeException e) {
			e.printStackTrace();
		} catch (IOException e) {
			e.printStackTrace();
		}
		return null;
	}

	// Method to decrypt of Entities
	public Object descyphE_x(SealedObject ep_dciph, SecretKey keySym) {
		try {
			Security.addProvider(new BouncyCastleProvider());
			Cipher dcifrador;
			dcifrador = Cipher.getInstance("DES/ECB/PKCS7Padding", "BC");
			dcifrador.init(Cipher.DECRYPT_MODE, keySym);
			return ep_dciph.getObject(dcifrador);

		} catch (NoSuchAlgorithmException e) {
			e.printStackTrace();
		} catch (NoSuchProviderException e) {
			e.printStackTrace();
		} catch (NoSuchPaddingException e) {
			e.printStackTrace();
		} catch (InvalidKeyException e) {
			e.printStackTrace();
		} catch (IllegalBlockSizeException e) {
			e.printStackTrace();
		} catch (BadPaddingException e) {
			e.printStackTrace();
		} catch (IOException e) {
			e.printStackTrace();
		} catch (ClassNotFoundException e) {
			e.printStackTrace();
		}
		return null;
	}

}
