/**
  * @author Oscar Sanchez Caadas. 14 Nov 2011
 * 
 */
import java.io.FileInputStream;
import java.io.IOException;
import java.security.KeyStore;
import java.security.KeyStoreException;
import java.security.NoSuchAlgorithmException;
import java.security.NoSuchProviderException;
import java.security.PrivateKey;
import java.security.UnrecoverableKeyException;
import java.security.cert.CertificateException;
import java.security.cert.CertificateFactory;
import java.security.cert.X509Certificate;
import java.security.spec.InvalidKeySpecException;

public class JKS {

	/**
	 * Key Store
	 */
	public static KeyStore JKSstart(String entryAlias)
			throws KeyStoreException, NoSuchAlgorithmException,
			CertificateException, IOException, UnrecoverableKeyException,
			NoSuchProviderException {
		String psswdAlias = entryAlias + "_pw";
		String keyStoreFileName = "/Users/osanchez/ECLIPSE/Peer_review_serv/Certificado/CAPFC/JKS/"
				+ entryAlias + ".jks"; //Path where key store file is saved
		FileInputStream in3 = new FileInputStream(keyStoreFileName);
		KeyStore kstore = KeyStore.getInstance("JKS", "SUN");
		kstore.load(in3, psswdAlias.toCharArray());
		return kstore;
	}

	public static X509Certificate getCertificate(KeyStore kstore,
			String entryAlias) throws KeyStoreException {
		return (X509Certificate) kstore.getCertificate(entryAlias);
	}

	public static PrivateKey getPrivateKey(KeyStore kstore, String entryAlias)
			throws UnrecoverableKeyException, KeyStoreException,
			NoSuchAlgorithmException, CertificateException, IOException,
			NoSuchProviderException, InvalidKeySpecException {

		return (PrivateKey) kstore.getKey(entryAlias,
				(entryAlias + "_pw").toCharArray());
	}

	public static java.security.cert.Certificate[] GenCert(String entryAlias)
			throws IOException, CertificateException {
		String certificateChainFileName = "/home/oscar/workspace/Peer_review_serv/Certificado/CAPFC/certs/"
				+ entryAlias + "-cert.pem"; //Path where certificated are saved
		// Load the certificate chain (in X.509 DER encoding).
		FileInputStream certificateStream = new FileInputStream(
				certificateChainFileName);
		CertificateFactory certificateFactory = CertificateFactory
				.getInstance("X.509");
		java.security.cert.Certificate[] cert = {};
		cert = certificateFactory.generateCertificates(certificateStream)
				.toArray(cert);
		certificateStream.close();
		return cert;
	}

}
