/**
  * @author Oscar Sanchez Caadas. 14 Nov 2011
 * 
 */

import java.io.FileNotFoundException;
import java.security.PrivateKey;
import java.util.Date;
import java.util.List;

public class PAutomRoutingReceiver {
	
	/**
	 *  Anonymous Routing Protocol at the receiver
	 */
	public Packet sendThroughPEA(Packet packet, PrivateKey privateKey,
			List<Entity> listaEntities) throws FileNotFoundException {
			SaveFile inf = new SaveFile();
			inf.saveInformationEntities(new
					Date()+" \t "+packet.getId_Entity()+" \t INF: "+"arrives new packet "+" \t \n");

		// Decrypting the packet using the private key
		packet.descypE_Pbk(privateKey);
		
		//Save the Symmetric key in log
		inf.saveInformationEntities(new
		Date()+" \t "+packet.getId_Entity()+" \t INF: keySym \t "+packet.get_keySym()+" \t \n");
		
		// Save the Size packet in log
		inf.saveInformationEntities(new
				Date()+" \t "+packet.getId_Entity()+" \t INF: Len packet - "+packet.get_len()+" \t \n");
		System.out.println("Len Packet: "+packet.get_len());

		if (!(packet.get_len() == 0)) {

			//Save error code in log
			inf.saveInformationEntities(new
					Date()+" \t "+packet.getId_Entity()+" \t INF: EC \t "+packet.get_EC()+" \t \n");
			
			// Decrypts the Ex packet, which have all except the last Entity
			packet.descyphEx(packet.get_keySym());
			
			// Role
			inf.saveInformationEntities(new
					Date()+" \t "+packet.getId_Entity()+" \t INF: Role \t "+packet.get_role()+" \t \n");
			
			// idNextEntity
			inf.saveInformationEntities(new
					Date()+" \t "+packet.getId_Entity()+" \t INF: idNextEntity \t "+packet.get_idNextEntity()+" \t \n");
			
			// NextPacket
			inf.saveInformationEntities(new
					Date()+" \t "+packet.getId_Entity()+" \t INF: NextPacket \t "+packet.get_idNextEntity()+" \t \n");
			
			// perform the action according to the mode of operation if it is destiny Entity
			if (packet.get_role().equalsIgnoreCase("destiny")) {
				switch (packet.get_op()) { 
				case 0:
					try {
						SaveFile sf = new SaveFile();
						inf.saveInformationEntities(new
								Date()+" \t "+packet.getId_Entity()+" \t INF: Destiny Entity verifying user authorization... \t \n");
						// Authz
						inf.saveInformationEntities(new
								Date()+" \t "+packet.getId_Entity()+" \t INF: Authz \t "+packet.get_authz()+" \t \n");
						
						if (packet.get_authz() != 1) {
							packet.set_EC((byte) 7); //if user do not have authorization specified error code
						}
						// Operation
						inf.saveInformationEntities(new
								Date()+" \t "+packet.getId_Entity()+" \t INF: Operation \t "+packet.get_op()+" \t \n");
						
						// Size data
						inf.saveInformationEntities(new
								Date()+" \t "+packet.getId_Entity()+" \t INF: Size data \t "+packet.get_len2()+" \t \n");
						
						// Data
						inf.saveInformationEntities(new
								Date()+" \t "+packet.getId_Entity()+" \t INF: Data \t Saving file... \t \n");
						
						inf.saveInformationEntities(new
								Date()+" \t "+packet.getId_Entity()+" \t INF: Data - "+packet.get_data()+" \t \n");
						
						// Save the data in a file
						int result = sf.saveFileReceived(packet.get_data(),
								listaEntities.get(packet.getId_Entity() - 1)
										.getNameEntity());
						if (result == 1) {
							packet.set_EC((byte) 1);
						} else {
							packet.set_EC((byte) 3);
						}

					} catch (FileNotFoundException e) {
						e.printStackTrace();
					}
					;
					break;
				case 1:
					System.out.println("Funtion not implemented");
					break;
				case 2:
					System.out.println("Funtion not implemented");
					break;
				case 3:
					System.out.println("Funtion not implemented");
					break;

				}

			}

			// EC
			packet.get_nextPacket().set_EC(packet.get_EC());
			if (packet.get_nextPacket().get_EC() == (byte) 1) {
				packet.get_nextPacket().set_padding(new byte[packet.get_lenData()]);//Padding with the same size as the file being transmitted
			}

			if (packet.get_role().equalsIgnoreCase("origen")) {

				inf.saveInformationEntities(new
						Date()+" \t "+packet.getId_Entity()+" \t INF: Origin Entity verifying messageId... \t \n");
				
				// MessageId
				inf.saveInformationEntities(new
						Date()+" \t "+packet.getId_Entity()+" \t INF: messageId \t "+packet.get_messageId()+" \t \n");
			}

		} else {
			// Last Entity
			inf.saveInformationEntities(new
					Date()+" \t "+packet.getId_Entity()+" \t INF: Last Entity \t Stop resend \t \n");
			}

		return packet;

	}

}
