/**
  * @author Oscar Sanchez Caadas. 14 Nov 2011
 * 
 */
import java.io.Serializable;
import java.io.UnsupportedEncodingException;
import java.security.InvalidKeyException;
import java.security.NoSuchAlgorithmException;
import java.security.PrivateKey;
import java.security.PublicKey;
import java.security.spec.InvalidKeySpecException;
import javax.crypto.SealedObject;
import javax.crypto.SecretKey;
import javax.crypto.SecretKeyFactory;
import javax.crypto.spec.DESKeySpec;

public class Packet implements Serializable {

	/**
	 *  Packets of Entities
	 */
	private static final long serialVersionUID = 9026472826382559155L;
	// Properties
	int id_Entity;
	SealedObject e_Pbk;
	SealedObject eX;
	byte[] _paddingLast; // To last Packet
	int _lenData;
	// Properties that appear after decrypt 
	int _len; // From: e_Pbk
	SecretKey _keySym; // From: e_Pbk
	String _role; // From: eX
	int _idNextEntity; // From: eX
	Packet _nextPacket; // From: eX
	// Only destiny Entity
	int _authz;
	int _op;
	int _len2;
	String _data;
	String _messageId;
	// Last Packet
	byte _EC; // error code
	byte[] _padding; // Padding optional

	// --Methods
	public int getId_Entity() {
		return id_Entity;
	}

	public void setId_Entity(int id_Entity) {
		this.id_Entity = id_Entity;
	}

	// To all Entities less  origin and destiny Entities
	public int cyphEx(String role, int idNextEntity, Packet nextPacket,
			SecretKey keySym) {
		Ex exCyph = new Ex();
		eX = exCyph.cyphE_x(role, idNextEntity, nextPacket, keySym);
		return eX.toString().length();
	}

	// Method to origin Entity 
	public int cyphEx(String role, String messageId, int idNextEntity,
			Packet nextPacket, SecretKey keySym) {
		Ex exCyph = new Ex();
		eX = exCyph.cyphE_x(role, messageId, idNextEntity, nextPacket, keySym);
		return eX.toString().length();
	}

	// Method to destiny Entity 
	public int cyphEx(String role, int authz, int op, int len2, String data,
			int idNextEntity, Packet nextPacket, SecretKey keySym) {
		Ex exCyph = new Ex();
		eX = exCyph.cyphE_x(role, authz, op, len2, data, idNextEntity,
				nextPacket, keySym);
		return eX.toString().length();
	}

	public void descyphEx(SecretKey keySym) {
		Ex exCyph = new Ex();
		// Decrypt last Packet
		exPack exPack = (exPack) exCyph.descyphE_x(eX, keySym);
		_role = exPack.getRole();
		_idNextEntity = exPack.getIdNextEntity();
		_nextPacket = (Packet) exPack.getNextPacket();
		if (exPack.getRole().equalsIgnoreCase("destiny")) {
			_authz = exPack.getAuthz();
			_op = exPack.getOp();
			_len2 = exPack.getLen2();
			_data = exPack.getData();
		}
		if (exPack.getRole().equalsIgnoreCase("origen")) {
			_messageId = exPack.getMessageId();
		}
	}

	public void cyphE_Pbk(String keySym, int len, PublicKey rsaPubKey) {

		Epbk_x ePbk_x = new Epbk_x();
		e_Pbk = ePbk_x.ciphEpbk_x(keySym, len, rsaPubKey);

	}

	public void descypE_Pbk(PrivateKey rsaPrvKey) {
		try {

			Epbk_x ePbk = new Epbk_x();
			epbk_xPack epbkPack = (epbk_xPack) ePbk.descyphEpbk_x(e_Pbk,
					rsaPrvKey);
			SecretKeyFactory skf = SecretKeyFactory.getInstance("DES");
			DESKeySpec kspec = new DESKeySpec(epbkPack.getKeySym().getBytes(
					"UTF8"));
			_keySym = skf.generateSecret(kspec);
			_len = epbkPack.getLen();

		} catch (NoSuchAlgorithmException e) {
			e.printStackTrace();
		}
		catch (InvalidKeySpecException e) {
			e.printStackTrace();
		} catch (InvalidKeyException e) {
			e.printStackTrace();
		} catch (UnsupportedEncodingException e) {
			e.printStackTrace();
		}
	}

	public int get_len() {
		return _len;
	}

	public SecretKey get_keySym() {
		return _keySym;
	}

	public String get_role() {
		return _role;
	}

	public int get_idNextEntity() {
		return _idNextEntity;
	}

	public Packet get_nextPacket() {
		return _nextPacket;
	}

	public int get_authz() {
		return _authz;
	}

	public String get_data() {
		return _data;
	}

	public int get_op() {
		return _op;
	}

	public int get_len2() {
		return _len2;
	}

	public String get_messageId() {
		return _messageId;
	}

	public byte[] get_padding() {
		return _padding;
	}

	public void set_padding(byte[] _padding) {
		this._padding = _padding;
	}

	public byte get_EC() {
		return _EC;
	}

	public void set_EC(byte _EC) {
		this._EC = _EC;
	}

	public byte[] get_paddingLast() {
		return _paddingLast;
	}

	public void set_paddingLast(byte[] _paddingLast) {
		this._paddingLast = _paddingLast;
	}

	public int get_lenData() {
		return _lenData;
	}

	public void set_lenData(int _lenData) {
		this._lenData = _lenData;
	}

}
