/**
  * @author Oscar Sanchez Caadas. 14 Nov 2011
 * 
 */

import java.io.ObjectInputStream;
import java.io.ObjectOutputStream;
import java.io.Serializable;
import java.net.Socket;
import java.security.KeyStore;
import java.util.ArrayList;
import java.util.List;
import java.io.BufferedReader;
import java.io.InputStreamReader;
import javax.net.ssl.SSLContext;
import javax.net.ssl.SSLSocket;
import javax.net.ssl.SSLSocketFactory;
import javax.net.ssl.TrustManager;
import javax.net.ssl.TrustManagerFactory;

public class UserApplication implements Serializable {

	/**
	  * User application to use the Anonymous Routing Protocol
	 * 
	 */
	private static final long serialVersionUID = -1747925486205160741L;

	public static void main(String[] args) {
		// Create client and the application ask for name of file
		UserApplication cf = new UserApplication();
		// Ask for free Entity to Directory
		cf.pideEntity("localhost", 33330);
	}

	public void pideEntity(String servidor, int puerto) {
		BufferedReader in = new BufferedReader(new InputStreamReader(System.in));
		try {
			// Create new user
			User usuario = new User();
			// Insert name of user
			System.out.print("User name: "); //User names inside certificates keystore: osc,ant,cvg,dvr y sgb
			// Wait for answering
			usuario.setName(in.readLine());

			int aux;

			do {
				// Insert the action
				System.out
						.print("[0] Publish document \n [1] Get document \n [2] Review document \n [3] Get reviews of document \n Choose an option: ");
				// Wait for answering through read channel 
				String leido = in.readLine();
				usuario.op = Integer.parseInt(leido);
				usuario.authz = 1;
				aux = 0;
				// Look at if it is to upload, download or modify
				if (!usuario.action) {
					if (!leido.contains("0") && !leido.contains("1")
							&& !leido.contains("2") && !leido.contains("3")) {
						System.out.print("Command not found.");
						aux = 1;
					}
				}
			} while (aux == 1);

			// Create socket to communicate with Directory
			Socket ssldirectory = new Socket(servidor, puerto);//**Must be modified to SSLsocket

			// Send user
			ObjectOutputStream OutputStream = new ObjectOutputStream(
					ssldirectory.getOutputStream());
			OutputStream.writeObject(usuario);

			// Receive user with list of Entities inside
			ObjectInputStream InputStream = new ObjectInputStream(
					ssldirectory.getInputStream());
			usuario = (User) InputStream.readObject();

			// Close socket with Directory
			ssldirectory.close();

			// Contact with Entity
			contactEntity(in, usuario, servidor);
		} catch (Exception e) {
			e.printStackTrace();
		}
	}

	public SSLSocket SSLSocketClientStart(String servidor, int port,
			String nameKS) throws Exception {

		KeyStore kstore = JKS.JKSstart(nameKS);
		TrustManagerFactory tmf = TrustManagerFactory.getInstance("SunX509");

		tmf.init(kstore);
		System.out.print(tmf.getTrustManagers());
		SSLContext context = SSLContext.getInstance("SSLv3");
		TrustManager[] trustManagers = tmf.getTrustManagers();

		context.init(null, trustManagers, null);

		SSLSocketFactory sf = context.getSocketFactory();

		SSLSocket s = (SSLSocket) sf.createSocket(servidor, port);
		return s;

	}

	public void contactEntity(BufferedReader in, User usuario,
			String servidor) {
		try {
			// Ask for name of file before contact with Entity
			System.out.print("User port:" + usuario.port);
			System.out.print("\nFile name: ");
			// Wait for answering
			usuario.setPathFile(in.readLine());

			// Extract list of Entities from User object
			List<Entity> listaEntities = new ArrayList<Entity>();
			listaEntities = usuario.getListaEntities();

			ReadFile rf = new ReadFile();
			String data = rf.readFile(usuario.getPathFile());

			// Send package to Anonymous Routing Protocol
			PAutomRoutingSender paSend = new PAutomRoutingSender();
			paSend.sendThroughPEA(listaEntities, usuario.getIdEntity(),
					usuario, data, servidor);
		} catch (Exception e) {
			e.printStackTrace();
		}
	}
}
